IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'POSICAO_ESTOQUE' AND
                 TYPE = 'P' 		           AND
	              U.UID = O.UID              AND
	              U.NAME = USER)
DROP PROCEDURE POSICAO_ESTOQUE
GO
CREATE PROCEDURE POSICAO_ESTOQUE(
   @P_FILIAL       VARCHAR(04),
   @P_PRODUTO      VARCHAR(10),
   @P_DTPOSICAO    DATETIME,
   @P_QTDEESTO     NUMERIC(15,5) OUTPUT,
   @P_VALRESTO     NUMERIC(15,5) OUTPUT,
   @P_VALRBRUT     NUMERIC(15,5) OUTPUT,
   @P_POSNZERO     VARCHAR(01) = 'N',
   @P_ALMOXARIFE   VARCHAR(06) = NULL,
   @P_LOCALESTOQ   VARCHAR(06) = NULL,
   @P_IDUTILALMOX  VARCHAR(01) = NULL,
   @P_IDUTILLCESTQ VARCHAR(01) = NULL,
   @P_IDUTILLOTE   VARCHAR(01) = NULL,
   @P_NRLOTEESTQ   VARCHAR(20) = NULL,
   @P_NRSUBLOTE    VARCHAR(04) = NULL)
AS
   DECLARE @V_QTDEESTO     NUMERIC(15,5);
   DECLARE @V_VALRESTO     NUMERIC(15,5);
   DECLARE @V_VALRBRUT     NUMERIC(15,5);
   DECLARE @V_QTDEANTE     NUMERIC(15,5);
   DECLARE @V_VALRANTE     NUMERIC(15,5);
   DECLARE @V_VRBRANTE     NUMERIC(15,5);
   DECLARE @V_QTDEESTOAUX  NUMERIC(15,5);
   DECLARE @V_VALRESTOAUX  NUMERIC(15,5);
   DECLARE @V_VALRBRUTAUX  NUMERIC(15,5);
   DECLARE @V_IDUTILALMOX  VARCHAR(01);
   DECLARE @V_IDUTILLCESTQ VARCHAR(01);
   DECLARE @V_IDUTILLOTE   VARCHAR(01);
   DECLARE @V_ALMOXARIFE   VARCHAR(06);
   DECLARE @V_LOCALESTOQ   VARCHAR(06);
   DECLARE @V_LOTEESTQ     VARCHAR(20);
   DECLARE @V_SUBLOTE      VARCHAR(04);

   /*VARIVEIS DO CURSOR C_LOCALIZACAO*/

   DECLARE @V_LOCAL_CDALMOXARIFE VARCHAR(06);
   DECLARE @V_LOCAL_CDLOCALESTOQ VARCHAR(06);

BEGIN
   SET @V_IDUTILALMOX  = NULL;
   SET @V_IDUTILLCESTQ = NULL;
   SET @V_IDUTILLOTE   = NULL;

   IF @P_IDUTILALMOX IS NULL BEGIN
      SELECT @V_IDUTILALMOX = ISNULL(MAX(IDUTILALMOX),'N'), @V_IDUTILLCESTQ = ISNULL(MAX(IDUTILLCESTQ),'N'), @V_IDUTILLOTE = ISNULL(MAX(IDUTILLOTE),'N')
      FROM PARAMFILIAL
      WHERE CDFILIAL = @P_FILIAL;
   END
   ELSE BEGIN
      SET @V_IDUTILALMOX  = @P_IDUTILALMOX;
      SET @V_IDUTILLCESTQ = @P_IDUTILLCESTQ;
      SET @V_IDUTILLOTE   = @P_IDUTILLOTE;
   END;

   IF @P_ALMOXARIFE IS NOT NULL BEGIN

      SET @V_ALMOXARIFE = @P_ALMOXARIFE;
      SET @V_LOCALESTOQ = @P_LOCALESTOQ;

      IF @P_NRLOTEESTQ IS NULL BEGIN
         EXEC CONSULTA_LOTE @V_IDUTILLOTE,
                            @P_FILIAL,
                            @V_ALMOXARIFE,
                            @V_LOCALESTOQ,
                            @P_PRODUTO,
                            @P_NRLOTEESTQ = @V_LOTEESTQ OUTPUT,
                            @P_NRSUBLOTE  = @V_SUBLOTE  OUTPUT;
      END
      ELSE BEGIN
         SET @V_LOTEESTQ = @P_NRLOTEESTQ;
         SET @V_SUBLOTE  = @P_NRSUBLOTE;
      END;
      EXEC CONSULTA_POSICAO @P_FILIAL, @P_PRODUTO, @P_DTPOSICAO,
                            @V_ALMOXARIFE, @V_LOCALESTOQ, @V_LOTEESTQ,
                            @V_SUBLOTE, @P_POSNZERO,
                            @P_QTDEESTO = @V_QTDEESTO OUTPUT,
                            @P_VALRESTO = @V_VALRESTO OUTPUT,
                            @P_VALRBRUT = @V_VALRBRUT OUTPUT;
   END
   ELSE BEGIN
      IF (@V_IDUTILLCESTQ = 'N') AND (@V_IDUTILALMOX = 'N') BEGIN
         SET @V_ALMOXARIFE = ' ';
         SET @V_LOCALESTOQ = ' ';

         IF @P_NRLOTEESTQ IS NULL BEGIN
            EXEC CONSULTA_LOTE @V_IDUTILLOTE,
                               @P_FILIAL,
                               @V_ALMOXARIFE,
                               @V_LOCALESTOQ,
                               @P_PRODUTO,
                               @P_NRLOTEESTQ = @V_LOTEESTQ OUTPUT,
                               @P_NRSUBLOTE  = @V_SUBLOTE  OUTPUT;
         END
         ELSE BEGIN
            SET @V_LOTEESTQ = @P_NRLOTEESTQ;
            SET @V_SUBLOTE  = @P_NRSUBLOTE;
         END;
         EXEC CONSULTA_POSICAO @P_FILIAL,     @P_PRODUTO,  @P_DTPOSICAO, @V_ALMOXARIFE,
                               @V_LOCALESTOQ, @V_LOTEESTQ, @V_SUBLOTE,   @P_POSNZERO,
                               @P_QTDEESTO = @V_QTDEESTOAUX OUTPUT,
                               @P_VALRESTO = @V_VALRESTOAUX OUTPUT,
                               @P_VALRBRUT = @V_VALRBRUTAUX OUTPUT;

         SET @P_QTDEESTO = @V_QTDEESTOAUX;
         SET @P_VALRESTO = @V_VALRESTOAUX;
         SET @P_VALRBRUT = @V_VALRBRUTAUX;
      END
      ELSE BEGIN
         SET @V_QTDEESTOAUX = 0;
         SET @V_VALRESTOAUX = 0;
         SET @V_VALRBRUTAUX = 0;

         DECLARE C_LOCALIZACAO CURSOR  FOR
         SELECT CDALMOXARIFE, CDLOCALESTOQ
         FROM LOCALESTOQUE
         WHERE CDFILIAL = @P_FILIAL
         OPEN C_LOCALIZACAO;
         FETCH NEXT FROM C_LOCALIZACAO INTO @V_LOCAL_CDALMOXARIFE, @V_LOCAL_CDLOCALESTOQ;
         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_ALMOXARIFE = @V_LOCAL_CDALMOXARIFE;
            SET @V_LOCALESTOQ = @V_LOCAL_CDLOCALESTOQ;

            IF @P_NRLOTEESTQ IS NULL BEGIN
               EXEC CONSULTA_LOTE @V_IDUTILLOTE,
                                  @P_FILIAL,
                                  @V_ALMOXARIFE,
                                  @V_LOCALESTOQ,
                                  @P_PRODUTO,
                                  @P_NRLOTEESTQ = @V_LOTEESTQ OUTPUT,
                                  @P_NRSUBLOTE  = @V_SUBLOTE  OUTPUT;
            END
            ELSE BEGIN
               SET @V_LOTEESTQ = @P_NRLOTEESTQ;
               SET @V_SUBLOTE  = @P_NRSUBLOTE;
            END;
            EXEC CONSULTA_POSICAO @P_FILIAL, @P_PRODUTO, @P_DTPOSICAO,
                                  @V_ALMOXARIFE, @V_LOCALESTOQ, @V_LOTEESTQ,
                                  @V_SUBLOTE, @P_POSNZERO,
                                  @P_QTDEESTO = @V_QTDEESTO OUTPUT,
                                  @P_VALRESTO = @V_VALRESTO OUTPUT,
                                  @P_VALRBRUT = @V_VALRBRUT OUTPUT;

            SET @V_QTDEESTOAUX = @V_QTDEESTOAUX + @V_QTDEESTO;
            SET @V_VALRESTOAUX = @V_VALRESTOAUX + @V_VALRESTO;
            SET @V_VALRBRUTAUX = @V_VALRBRUTAUX + @V_VALRBRUT;
            FETCH NEXT FROM C_LOCALIZACAO INTO @V_LOCAL_CDALMOXARIFE, @V_LOCAL_CDLOCALESTOQ;
         END;
         CLOSE C_LOCALIZACAO;
         DEALLOCATE C_LOCALIZACAO;
         SET @P_QTDEESTO = @V_QTDEESTOAUX;
         SET @P_VALRESTO = @V_VALRESTOAUX;
         SET @P_VALRBRUT = @V_VALRBRUTAUX;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'POSICAO_ESTOQUE','4.05.109';
GO

